require "tesla_brain/version"

module TeslaBrain
  class Error < StandardError; end

  class Brain

    def self.unconscious
      input     = File.read("input/unconscious/config_input.txt").strip.to_i

      attribute = ["Unconscious"]

      training  = [
                  [8.0,      "entertain"],    [1.0,       "power_on"],

        [7.0, "farewell_agent"],                          [2.0,    "greet_agent"],

                  [5.0,     "power_down"],    [4.0,  "request_input"],
      ]

      dec_tree = DecisionTree::ID3Tree.new(attribute, training, "power_on", :continuous)
      dec_tree.train

      test = [input] 

      prediction = dec_tree.predict(test)
      actuality  = test.last

      puts "Prediction: #{prediction}"
      puts "Actuality:  #{actuality}"

      sleep(3)

      puts " "
    end

    def self.conscious
      input = File.read("input/conscious/config_input.txt").strip.to_i

      attribute = ["Conscious"]

      training  = [
                               [9.0,       "hybrid"],

        [6.0,      "gabbler"],                        [3.0, "decisiontree"],
      ]

      dec_tree = DecisionTree::ID3Tree.new(attribute, training, "decisiontree", :continuous)
      dec_tree.train

      test = [input] 

      prediction = dec_tree.predict(test)
      actuality  = test.last

      puts "Prediction: #{prediction}"
      puts "Actuality:  #{actuality}"

      sleep(3)

      puts " "
    end

  end
end
